



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>【Spring源码解读】bean标签中的属性</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">【Spring源码解读】bean标签中的属性</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-01 17:09:08 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<h2>说明</h2>
<p>今天在阅读Spring源码的时候，发现在加载xml中的bean时，解析了很多标签，其中有常用的如：scope、autowire、lazy-init、init-method、destroy-method等等。但还有很多很少用甚至没用过的标签，看来对这个经常使用的框架，还是知之甚少，本着探索的精神，决定将bean中所有相关标签的作用做一次整理，以便完善自己的知识体系。</p>
<p>另外，说明一下，使用的Spring源码版本为当前最新版本<code>5.2.0.BUILD-SNAPSHOT</code>，跟老版本中的相关代码可能会有少数差异。</p>
<h2>Spring中对属性标签的解析</h2>
<p>解析Spring中bean的属性标签的源码位置位于类：<code>BeanDefinitionParserDelegate</code> 的 <code>parseBeanDefinitionAttributes</code> 方法中，源码如下：</p>
<pre class="prettyprint linenums"><code>public AbstractBeanDefinition parseBeanDefinitionAttributes(Element ele, String beanName,<br />
        @Nullable BeanDefinition containingBean, AbstractBeanDefinition bd) {

    // 解析 singleton 属性，当前版本已不支持该属性，如使用将会抛出异常<br />
    if (ele.hasAttribute(SINGLETON_ATTRIBUTE)) {<br />
        error(&quot;Old 1.x 'singleton' attribute in use - upgrade to 'scope' declaration&quot;, ele);<br />
    }<br />
    // 解析 scope 属性<br />
    else if (ele.hasAttribute(SCOPE_ATTRIBUTE)) {<br />
        bd.setScope(ele.getAttribute(SCOPE_ATTRIBUTE));<br />
    }<br />
    else if (containingBean != null) {<br />
        // 如果当前 bean 没有设置 scope 属性且当前 bean 是其他 bean 的内部 bean，则设置为其外部 bean 的 scope 属性值<br />
        bd.setScope(containingBean.getScope());<br />
    }

    // 解析 abstract 属性<br />
    if (ele.hasAttribute(ABSTRACT_ATTRIBUTE)) {<br />
        bd.setAbstract(TRUE_VALUE.equals(ele.getAttribute(ABSTRACT_ATTRIBUTE)));<br />
    }

    // 解析 lazy-init 属性<br />
    String lazyInit = ele.getAttribute(LAZY_INIT_ATTRIBUTE);<br />
    if (isDefaultValue(lazyInit)) {<br />
        lazyInit = this.defaults.getLazyInit();<br />
    }<br />
    bd.setLazyInit(TRUE_VALUE.equals(lazyInit));

    // 解析 autowire 属性<br />
    String autowire = ele.getAttribute(AUTOWIRE_ATTRIBUTE);<br />
    bd.setAutowireMode(getAutowireMode(autowire));

    // 解析 depends-on 属性<br />
    if (ele.hasAttribute(DEPENDS_ON_ATTRIBUTE)) {<br />
        String dependsOn = ele.getAttribute(DEPENDS_ON_ATTRIBUTE);<br />
        bd.setDependsOn(StringUtils.tokenizeToStringArray(dependsOn, MULTI_VALUE_ATTRIBUTE_DELIMITERS));<br />
    }

    // 解析 autowire-candidate 属性<br />
    String autowireCandidate = ele.getAttribute(AUTOWIRE_CANDIDATE_ATTRIBUTE);<br />
    if (isDefaultValue(autowireCandidate)) {<br />
        String candidatePattern = this.defaults.getAutowireCandidates();<br />
        if (candidatePattern != null) {<br />
            String[] patterns = StringUtils.commaDelimitedListToStringArray(candidatePattern);<br />
            bd.setAutowireCandidate(PatternMatchUtils.simpleMatch(patterns, beanName));<br />
        }<br />
    }<br />
    else {<br />
        bd.setAutowireCandidate(TRUE_VALUE.equals(autowireCandidate));<br />
    }

    // 解析 primary 属性<br />
    if (ele.hasAttribute(PRIMARY_ATTRIBUTE)) {<br />
        bd.setPrimary(TRUE_VALUE.equals(ele.getAttribute(PRIMARY_ATTRIBUTE)));<br />
    }

    // 解析 init-method 属性<br />
    if (ele.hasAttribute(INIT_METHOD_ATTRIBUTE)) {<br />
        String initMethodName = ele.getAttribute(INIT_METHOD_ATTRIBUTE);<br />
        bd.setInitMethodName(initMethodName);<br />
    }<br />
    else if (this.defaults.getInitMethod() != null) {<br />
        // 如果没有设置该属性，则设置为默认值<br />
        bd.setInitMethodName(this.defaults.getInitMethod());<br />
        bd.setEnforceInitMethod(false);<br />
    }

    // 解析 destroy-method 属性<br />
    if (ele.hasAttribute(DESTROY_METHOD_ATTRIBUTE)) {<br />
        String destroyMethodName = ele.getAttribute(DESTROY_METHOD_ATTRIBUTE);<br />
        bd.setDestroyMethodName(destroyMethodName);<br />
    }<br />
    else if (this.defaults.getDestroyMethod() != null) {<br />
        bd.setDestroyMethodName(this.defaults.getDestroyMethod());<br />
        bd.setEnforceDestroyMethod(false);<br />
    }

    // 解析 factory-method 属性<br />
    if (ele.hasAttribute(FACTORY_METHOD_ATTRIBUTE)) {<br />
        bd.setFactoryMethodName(ele.getAttribute(FACTORY_METHOD_ATTRIBUTE));<br />
    }

    // 解析 factory-bean 属性<br />
    if (ele.hasAttribute(FACTORY_BEAN_ATTRIBUTE)) {<br />
        bd.setFactoryBeanName(ele.getAttribute(FACTORY_BEAN_ATTRIBUTE));<br />
    }

    return bd;<br />
}<br />
</code></pre>
<p>里面可以看到对 bean 标签中的很多属性进行了解析，接下来的几篇里，就来看看每个属性的作用。（第一个已经废弃的属性就不说了												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/4qndx328.html">win下sass安装失败的一种可能</a>
		</li>
						<li><a href="https://www.batexi.com/a/o8o3dw18.html">13&period;Xcode开发的快捷键</a>
		</li>
						<li><a href="https://www.batexi.com/a/0qwe7mzq.html">&lbrack;Android Pro&rsqb;   How to get recent tasks on Android &OpenCurlyDoubleQuote;L&rdquo;&quest;</a>
		</li>
						<li><a href="https://www.batexi.com/a/5qyk7pd9.html">明天去FDUSC报道了，GOD BLESS ALL OF US</a>
		</li>
						<li><a href="https://www.batexi.com/a/5qx0gedq.html">c&num; ini file</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rd654e8.html">Source Insight新建工程文件</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pje2ek9.html">2015年9月28日html基础了解学习</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2w1myoq.html">SRM 601&lpar;1-250pt&comma;500pt&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/8ok7n6x9.html">Windows上安装Xampp后通过命令行进入MariaDB</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4z4pje9.html">maven下载，安装与eclipse中maven配置</a>
		</li>
						<li><a href="https://www.batexi.com/a/8eyg3je9.html">EIGRP 基础实验</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2jp76x8.html">SpringBoot 集成 Swageer2</a>
		</li>
						<li><a href="https://www.batexi.com/a/qlle2ekq.html">2017年11月23日&ast;&ast;科技面试java工程师面试总结</a>
		</li>
						<li><a href="https://www.batexi.com/a/90rnr649.html">Prometheus 监控进程</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kj34639.html">Java基础知识你知道多少？</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4je0mjq.html">unity 获取水平FOV</a>
		</li>
						<li><a href="https://www.batexi.com/a/953v7pe8.html">JavaScript中的闭包（closure）</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rn2xo4q.html">&lbrack;转&rsqb;C&num;中Timer使用及解决重入问题</a>
		</li>
						<li><a href="https://www.batexi.com/a/963er6y9.html">Java中的集合框架-Collections和Arrays</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2kplllq.html">使用union all 遇到的问题（俩条sql语句行数的和 不等于union all 后的 行数的和 ！）；遗留问题 怎么找到 相差的呐俩条数据  ？</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/qnvvlxj8.html">&commat;vue&sol;cli 构建得项目eslint配置</a>
			</li>
						<li><a href="https://www.batexi.com/a/qlll710q.html">JS获取链接中域名等信息</a>
			</li>
						<li><a href="https://www.batexi.com/a/qyyyn4mq.html">Android UI（一）Layout 背景局部Shape圆角设计</a>
			</li>
						<li><a href="https://www.batexi.com/a/q4jj1n3q.html">Windows 下获取硬盘序列号</a>
			</li>
						<li><a href="https://www.batexi.com/a/qdwwv3v9.html">Win32之内存管理之虚拟内存跟物理内存</a>
			</li>
						<li><a href="https://www.batexi.com/a/q1rr6448.html">Cookie提要</a>
			</li>
						<li><a href="https://www.batexi.com/a/8m227z6q.html">深入学习主成分分析（PCA）算法原理（Python实现）</a>
			</li>
						<li><a href="https://www.batexi.com/a/93ww4rwq.html">MySQL高可用之组复制&lpar;4&rpar;：详细分析组复制理论</a>
			</li>
						<li><a href="https://www.batexi.com/a/qlll420q.html">python下载安装BeautifulSoup库</a>
			</li>
						<li><a href="https://www.batexi.com/a/8kjjx059.html">AFNetworking封装-项目使用</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
